## cri-o 1.28.1~0

=== Makefile ===
GO ?= go

export GOPROXY=https://proxy.golang.org
export GOSUMDB=https://sum.golang.org

TRIMPATH ?= -trimpath
GO_ARCH=$(shell $(GO) env GOARCH)
GO_MAJOR_VERSION = $(shell $(GO) version | cut -c 14- | cut -d' ' -f1 | cut -d'.' -f1)
GO_MINOR_VERSION = $(shell $(GO) version | cut -c 14- | cut -d' ' -f1 | cut -d'.' -f2)
GO_GT_1_17 := $(shell [ $(GO_MAJOR_VERSION) -ge 1 -a $(GO_MINOR_VERSION) -ge 17 ] && echo true)
GO_FLAGS ?=
ifeq ($(GO_GT_1_17),true)
ifeq ($(GO_ARCH),386)
GO_FLAGS += -buildvcs=false
endif
endif

GO_BUILD ?= $(GO) build $(GO_FLAGS) $(TRIMPATH)
GO_RUN ?= $(GO) run
NIX_IMAGE ?= nixos/nix:2.3.16

PROJECT := github.com/cri-o/cri-o
CRIO_INSTANCE := crio_dev
PREFIX ?= ${DESTDIR}/usr/local
BINDIR ?= ${PREFIX}/bin
LIBEXECDIR ?= ${PREFIX}/libexec
MANDIR ?= ${PREFIX}/share/man
ETCDIR ?= ${DESTDIR}/etc
ETCDIR_CRIO ?= ${ETCDIR}/crio
DATAROOTDIR ?= ${PREFIX}/share/containers
BUILDTAGS ?= containers_image_ostree_stub \
			 $(shell hack/apparmor_tag.sh) \
			 $(shell hack/btrfs_installed_tag.sh) \
			 $(shell hack/btrfs_tag.sh) \
			 $(shell hack/libdm_installed.sh) \
			 $(shell hack/libdm_no_deferred_remove_tag.sh) \
			 $(shell hack/openpgp_tag.sh) \
			 $(shell hack/seccomp_tag.sh) \
			 $(shell hack/selinux_tag.sh) \
			 $(shell hack/libsubid_tag.sh)
CRICTL_CONFIG_DIR=${DESTDIR}/etc
CONTAINER_RUNTIME ?= podman
BUILD_PATH := $(shell pwd)/build
BUILD_BIN_PATH := ${BUILD_PATH}/bin
COVERAGE_PATH := ${BUILD_PATH}/coverage
TESTBIN_PATH := ${BUILD_PATH}/test
MOCK_PATH := ${PWD}/test/mocks

BASHINSTALLDIR=${PREFIX}/share/bash-completion/completions
FISHINSTALLDIR=${PREFIX}/share/fish/completions
ZSHINSTALLDIR=${PREFIX}/share/zsh/site-functions
OCIUMOUNTINSTALLDIR=$(PREFIX)/share/oci-umount/oci-umount.d

SELINUXOPT ?= $(shell selinuxenabled 2>/dev/null && echo -Z)

SOURCE_DATE_EPOCH ?= $(shell date +%s)

GO_MD2MAN ?= ${BUILD_BIN_PATH}/go-md2man
GINKGO := ${BUILD_BIN_PATH}/ginkgo
MOCKGEN := ${BUILD_BIN_PATH}/mockgen
MOCKGEN_VERSION := 1.6.0
GOLANGCI_LINT := ${BUILD_BIN_PATH}/golangci-lint
GOLANGCI_LINT_VERSION := v1.53.2
GO_MOD_OUTDATED := ${BUILD_BIN_PATH}/go-mod-outdated
GO_MOD_OUTDATED_VERSION := 0.9.0
GOSEC := ${BUILD_BIN_PATH}/gosec
GOSEC_VERSION := 2.15.0
RELEASE_NOTES := ${BUILD_BIN_PATH}/release-notes
ZEITGEIST := ${BUILD_BIN_PATH}/zeitgeist
ZEITGEIST_VERSION := v0.4.1
RELEASE_NOTES_VERSION := v0.15.1
BOM := ${BUILD_BIN_PATH}/bom
BOM_VERSION := v0.5.1
SHFMT := ${BUILD_BIN_PATH}/shfmt
SHFMT_VERSION := v3.6.0
SHELLCHECK := ${BUILD_BIN_PATH}/shellcheck
SHELLCHECK_VERSION := v0.9.0
BATS_FILES := $(wildcard test/*.bats)

ifeq ($(shell bash -c '[[ `command -v git` && `git rev-parse --git-dir 2>/dev/null` ]] && echo true'), true)
	COMMIT_NO := $(shell git rev-parse HEAD 2> /dev/null || true)
	GIT_TREE_STATE := $(if $(shell git status --porcelain --untracked-files=no),dirty,clean)
else
	COMMIT_NO := unknown
	GIT_TREE_STATE := unknown
endif

# pass crio CLI options to generate custom configuration options at build time
CONF_OVERRIDES ?=

CROSS_BUILD_TARGETS := \
	bin/crio.cross.windows.amd64 \
	bin/crio.cross.darwin.amd64 \
	bin/crio.cross.linux.amd64

GO_FILES := $(shell find . -type f -name '*.go' -not -name '*_test.go')

# Some of the packages use the golang testing infra in end-to-end tests.
# These can't be run as unit tests so ginkgo should skip them.
GINKGO_SKIP_PACKAGES = test/nri

# Set DEBUG=1 to enable debug symbols in binaries
DEBUG ?= 0
ifeq ($(DEBUG),0)
SHRINKFLAGS = -s -w
else
GCFLAGS = -gcflags '-N -l'
endif

DATE_FMT = +'%Y-%m-%dT%H:%M:%SZ'
ifdef SOURCE_DATE_EPOCH
    BUILD_DATE ?= $(shell date -u -d "@$(SOURCE_DATE_EPOCH)" "$(DATE_FMT)" 2>/dev/null || date -u -r "$(SOURCE_DATE_EPOCH)" "$(DATE_FMT)" 2>/dev/null || date -u "$(DATE_FMT)")
else
    BUILD_DATE ?= $(shell date -u "$(DATE_FMT)")
endif

BASE_LDFLAGS = ${SHRINKFLAGS} \
	-X ${PROJECT}/internal/version.buildDate=${BUILD_DATE}

GO_LDFLAGS = -ldflags '${BASE_LDFLAGS} ${EXTRA_LDFLAGS}'

all: binaries crio.conf docs

default: help

help:
	@echo "Usage: make <target>"
	@echo
	@echo " * 'install' - Install binaries to system locations"
	@echo " * 'binaries' - Build crio and pinns"
	@echo " * 'release-note' - Generate release note"
	@echo " * 'localintegration' - Execute integration tests"
	@echo " * 'clean' - Clean artifacts"
	@echo " * 'lint' - Execute the source code linter"
	@echo " * 'shfmt' - shell format check and apply diff"
	@echo " * 'shellcheck' - Execute the shellcheck linter"

# Dummy target for marking pattern rules phony
.explicit_phony:

# See also: .github/workflows/verify.yml.
lint:  ${GOLANGCI_LINT}
	${GOLANGCI_LINT} version
	${GOLANGCI_LINT} linters
	GL_DEBUG=gocritic ${GOLANGCI_LINT} run

check-log-lines:
	./hack/log-capitalized.sh
	./hack/tree_status.sh

check-config-template:
	./hack/validate-config.sh

shellfiles: ${SHFMT}
	$(eval SHELLFILES=$(shell ${SHFMT} -f . | grep -v vendor/ | grep -v hack/lib | grep -v hack/build-rpms.sh | grep -v .bats))

shfmt: shellfiles
	${SHFMT} -ln bash -w -i 4 -d ${SHELLFILES}
	${SHFMT} -ln bats -w -sr -d $(BATS_FILES)

shellcheck: shellfiles ${SHELLCHECK}
	${SHELLCHECK} \
		-P contrib/bundle \
		-P scripts \
		-P test \
		-x \
		${SHELLFILES} ${BATS_FILES}

check-nri-bats-tests: test/nri/nri.test
	./hack/check-nri-bats-tests.sh

bin/pinns:
	$(MAKE) -C pinns

test/copyimg/copyimg: $(GO_FILES)
	$(GO_BUILD) $(GCFLAGS) $(GO_LDFLAGS) -tags "$(BUILDTAGS)" -o $@ $(PROJECT)/test/copyimg

test/checkseccomp/checkseccomp: $(GO_FILES)
	$(GO_BUILD) $(GCFLAGS) $(GO_LDFLAGS) -tags "$(BUILDTAGS)" -o $@ $(PROJECT)/test/checkseccomp

test/checkcriu/checkcriu: $(GO_FILES)
	$(GO_BUILD) $(GCFLAGS) $(GO_LDFLAGS) -tags "$(BUILDTAGS)" -o $@ $(PROJECT)/test/checkcriu

test/nri/nri.test: $(wildcard test/nri/*.go)
	$(GO) test --tags "test $(BUILDTAGS)" -c $(PROJECT)/test/nri -o $@

bin/crio: $(GO_FILES)
	$(GO_BUILD) $(GCFLAGS) $(GO_LDFLAGS) -tags "$(BUILDTAGS)" -o $@ $(PROJECT)/cmd/crio

bin/crio-status: $(GO_FILES)
	$(GO_BUILD) $(GCFLAGS) $(GO_LDFLAGS) -tags "$(BUILDTAGS)" -o $@ $(PROJECT)/cmd/crio-status

build-static:
	$(CONTAINER_RUNTIME) run --network=host --rm --privileged -ti -v /:/mnt \
		$(NIX_IMAGE) cp -rfT /nix /mnt/nix
	$(CONTAINER_RUNTIME) run --network=host --rm --privileged -ti -v /nix:/nix -v ${PWD}:${PWD} -w ${PWD} \
		$(NIX_IMAGE) nix --print-build-logs --option cores 8 --option max-jobs 8 build --file nix/
	mkdir -p bin
	cp -r result/bin bin/static

release-bundle: clean bin/pinns build-static docs crio.conf bundle

crio.conf: bin/crio
	./bin/crio -d "" --config="" $(CONF_OVERRIDES) config > crio.conf

release:
	${GO_RUN} ./scripts/release

release-notes: ${RELEASE_NOTES}
	${GO_RUN} ./scripts/release-notes \
		--output-path ${BUILD_PATH}/release-notes

dependencies: ${GO_MOD_OUTDATED}
	${GO_RUN} ./scripts/dependencies \
		--output-path ${BUILD_PATH}/dependencies

clean:
	rm -rf _output
	rm -f docs/*.5 docs/*.8
	rm -fr test/testdata/redis-image
	find . -name \*~ -delete
	find . -name \#\* -delete
	rm -rf bin/
	$(MAKE) -C pinns clean
	rm -f test/copyimg/copyimg
	rm -f test/checkseccomp/checkseccomp
	rm -f test/checkcriu/checkcriu
	rm -f test/nri/nri.test
	rm -rf ${BUILD_BIN_PATH}

# the approach here, rather than this target depending on the build targets
# directly, is such that each target should try to build regardless if it
# fails. And return a non-zero exit if _any_ target fails.
local-cross:
	@$(MAKE) --keep-going $(CROSS_BUILD_TARGETS)

bin/crio.cross.%:  .explicit_phony
	@echo "==> make $@"; \
	TARGET="$*"; \
	GOOS="$${TARGET%%.*}" \
	GOARCH="$${TARGET##*.}" \
	$(GO_BUILD) $(GO_LDFLAGS) -tags "containers_image_openpgp btrfs_noversion" -o "$@" $(PROJECT)/cmd/crio

nixpkgs:
	@nix run -f channel:nixpkgs-unstable nix-prefetch-git -- \
		--no-deepClone https://github.com/nixos/nixpkgs > nix/nixpkgs.json

define go-build
	$(shell cd `pwd` && $(GO_BUILD) -o $(BUILD_BIN_PATH)/$(shell basename $(1)) $(1))
	@echo > /dev/null
endef

$(BUILD_BIN_PATH):
	mkdir -p $(BUILD_BIN_PATH)

$(GO_MD2MAN):
	$(call go-build,./vendor/github.com/cpuguy83/go-md2man)

$(GINKGO):
	$(call go-build,./vendor/github.com/onsi/ginkgo/v2/ginkgo)

define curl_to
    curl -sSfL --retry 5 --retry-delay 3 "$(1)" -o $(2)
	chmod +x $(2)
endef

$(RELEASE_NOTES): $(BUILD_BIN_PATH)
	$(call curl_to,https://github.com/kubernetes/release/releases/download/$(RELEASE_NOTES_VERSION)/release-notes-linux-amd64,$(RELEASE_NOTES))

$(SHFMT): $(BUILD_BIN_PATH)
	$(call curl_to,https://github.com/mvdan/sh/releases/download/$(SHFMT_VERSION)/shfmt_$(SHFMT_VERSION)_linux_amd64,$(SHFMT))

$(ZEITGEIST): $(BUILD_BIN_PATH)
	$(call curl_to,https://github.com/kubernetes-sigs/zeitgeist/releases/download/$(ZEITGEIST_VERSION)/zeitgeist_$(ZEITGEIST_VERSION:v%=%)_linux_amd64,$(BUILD_BIN_PATH)/zeitgeist)

$(BOM): $(BUILD_BIN_PATH)
	$(call curl_to,https://github.com/kubernetes-sigs/bom/releases/download/$(BOM_VERSION)/bom-amd64-linux,$(BUILD_BIN_PATH)/bom)

$(MOCKGEN): $(BUILD_BIN_PATH)
	$(call curl_to,https://github.com/golang/mock/releases/download/v$(MOCKGEN_VERSION)/mock_$(MOCKGEN_VERSION)_linux_amd64.tar.gz,$(BUILD_BIN_PATH)/mockgen.tar.gz)
	tar xf $(BUILD_BIN_PATH)/mockgen.tar.gz --strip-components=1 -C $(BUILD_BIN_PATH)

$(GO_MOD_OUTDATED): $(BUILD_BIN_PATH)
	$(call curl_to,https://github.com/psampaz/go-mod-outdated/releases/download/v$(GO_MOD_OUTDATED_VERSION)/go-mod-outdated_$(GO_MOD_OUTDATED_VERSION)_Linux_x86_64.tar.gz,$(BUILD_BIN_PATH)/gmo.tar.gz)
	tar xf $(BUILD_BIN_PATH)/gmo.tar.gz -C $(BUILD_BIN_PATH)

$(GOSEC): $(BUILD_BIN_PATH)
	$(call curl_to,https://github.com/securego/gosec/releases/download/v$(GOSEC_VERSION)/gosec_$(GOSEC_VERSION)_linux_amd64.tar.gz,$(BUILD_BIN_PATH)/gosec.tar.gz)
	tar xf $(BUILD_BIN_PATH)/gosec.tar.gz -C $(BUILD_BIN_PATH)

bom: $(BOM)

$(GOLANGCI_LINT):
	export VERSION=$(GOLANGCI_LINT_VERSION) \
		URL=https://raw.githubusercontent.com/golangci/golangci-lint \
		BINDIR=${BUILD_BIN_PATH} && \
	curl -sSfL $$URL/$$VERSION/install.sh | sh -s $$VERSION

$(SHELLCHECK): $(BUILD_BIN_PATH)
	URL=https://github.com/koalaman/shellcheck/releases/download/$(SHELLCHECK_VERSION)/shellcheck-$(SHELLCHECK_VERSION).linux.x86_64.tar.xz \
	SHA256SUM=7087178d54de6652b404c306233264463cb9e7a9afeb259bb663cc4dbfd64149 && \
	curl -sSfL $$URL | tar xfJ - -C ${BUILD_BIN_PATH} --strip 1 shellcheck-$(SHELLCHECK_VERSION)/shellcheck && \
	sha256sum ${SHELLCHECK} | grep -q $$SHA256SUM

vendor: export GOSUMDB :=
vendor:
	$(GO) mod tidy
	$(GO) mod vendor
	$(GO) mod verify

check-vendor: vendor
	./hack/tree_status.sh

testunit: ${GINKGO}
	rm -rf ${COVERAGE_PATH} && mkdir -p ${COVERAGE_PATH}
	${BUILD_BIN_PATH}/ginkgo run \
		${TESTFLAGS} \
		-r \
		--skip-package $(GINKGO_SKIP_PACKAGES) \
		--trace \
		--cover \
		--covermode atomic \
		--output-dir ${COVERAGE_PATH} \
		--junit-report junit.xml \
		--coverprofile coverprofile \
		--tags "test $(BUILDTAGS)" \
		$(GO_MOD_VENDOR) \
		--succinct
	$(GO) tool cover -html=${COVERAGE_PATH}/coverprofile -o ${COVERAGE_PATH}/coverage.html

testunit-bin:
	mkdir -p ${TESTBIN_PATH}
	for PACKAGE in `$(GO) list ./...`; do \
		go test $$PACKAGE \
			--tags "test $(BUILDTAGS)" \
			--gcflags '-N' -c -o ${TESTBIN_PATH}/$$(basename $$PACKAGE) ;\
	done

mockgen: \
	mock-cmdrunner \
	mock-containerstorage \
	mock-criostorage \
	mock-lib-config \
	mock-oci \
	mock-image-types \
	mock-ocicni-types

mock-containereventserver: ${MOCKGEN}
	${MOCKGEN} \
		-package containereventservermock \
		-destination ${MOCK_PATH}/containereventserver/containereventserver.go \
		k8s.io/cri-api/pkg/apis/runtime/v1 RuntimeService_GetContainerEventsServer

mock-containerstorage: ${MOCKGEN}
	${MOCKGEN} \
		-package containerstoragemock \
		-destination ${MOCK_PATH}/containerstorage/containerstorage.go \
		github.com/containers/storage Store

mock-cmdrunner: ${MOCKGEN}
	${MOCKGEN} \
		-package cmdrunnermock \
		-destination ${MOCK_PATH}/cmdrunner/cmdrunner.go \
		github.com/cri-o/cri-o/utils/cmdrunner CommandRunner

mock-criostorage: ${MOCKGEN}
	${MOCKGEN} \
		-package criostoragemock \

=== debian/changelog ===
cri-o (1.28.1~0) stable; urgency=medium

  * bump to v1.28.1

 -- Peter Hunt <haircommander@fedoraproject.org>  Fri, 15 Sep 2023 19:13:48 +0530

cri-o (1.28.0~0) stable; urgency=medium

  * bump to v1.28.0

 -- Peter Hunt <haircommander@fedoraproject.org>  Mon, 28 Aug 2023 11:29:01 +0530

=== debian/rules ===
#!/usr/bin/make -f

DH_VERBOSE := 1
DH_GOPKG := github.com/cri-o/cri-o
BUILDDIR := $(shell pwd)
DESTDIR := $(BUILDDIR)/debian/cri-o
PREFIX := /usr
BINDIR := $(DESTDIR)$(PREFIX)/bin
UNITDIR := $(DESTDIR)$(PREFIX)/lib/systemd/system
SYSCONFDIR := $(DESTDIR)/etc/default
BUILDTAGS := 'apparmor seccomp containers_image_ostree_stub exclude_graphdriver_btrfs exclude_graphdriver_devicemapper containers_image_openpgp'
GO_MD2MAN := /usr/bin/go-md2man

define CRIO_CONF_OVERRIDE
[crio.runtime.runtimes.runc]
runtime_path = "/usr/lib/cri-o-runc/sbin/runc"
runtime_type = "oci"
runtime_root = "/run/runc"
endef
export CRIO_CONF_OVERRIDE

ifneq (,$(wildcard /usr/lib/go-1.19/bin/go))
        GO_BINARY := /usr/lib/go-1.19/bin/go
else
        GO_BINARY := /usr/bin/go
endif
GO := GOPATH=$(BUILDDIR) GO111MODULE=off $(GO_BINARY)
GO_BUILD := "$(GO) build"
UPSTREAM_TAG=v1.28.1

%:
	dh_clean
	make clean
	rm -rf $(BUILDDIR)/obj-*-linux-gnu $(BUILDDIR)/debian/cri-o/*
	rm -rf $(BUILDDIR)/src $(BUILDDIR)/crio.conf $(BUILDDIR)/pkg/linux_*
	dh $@ --buildsystem=golang --with=golang

override_dh_auto_configure:
	# Include vendored dependencies.
	cp -rp $(BUILDDIR)/vendor $(BUILDDIR)/src
	ln -s $(BUILDDIR) $(BUILDDIR)/src/$(DH_GOPKG)

override_dh_auto_build:
	make \
	   GOPATH=$(BUILDDIR) \
	   GO_BUILD=$(GO_BUILD) \
	   BUILDTAGS=$(BUILDTAGS) \
	   PROJECT=$(DH_GOPKG) \
	   binaries docs

override_dh_auto_test:

override_dh_auto_install:
	make \
	   PREFIX=$(DESTDIR)/usr \
	   CRICTL_CONFIG_DIR=$(DESTDIR)/etc \
	   ETCDIR_CRIO=$(DESTDIR)/etc/crio \
	   GO_MD2MAN=$(GO_MD2MAN) \
	   GOPATH=$(BUILDDIR) \
	   GO_BUILD=$(GO_BUILD) \
	   CRICTL_CONFIG_DIR=$(DESTDIR)/etc \
	   install.bin-nobuild \
	   install.completions \
	   install.config \
	   install.man-nobuild \
	   install.systemd
	# install binaries
	install -dp $(DESTDIR)/etc/cni/net.d
	install -p -m 644 contrib/cni/10-crio-bridge.conflist $(DESTDIR)/etc/cni/net.d/100-crio-bridge.conflist
	install -p -m 644 contrib/cni/99-loopback.conflist $(DESTDIR)/etc/cni/net.d/200-loopback.conflist
	install -dp $(SYSCONFDIR)
	install -p -m 644 contrib/sysconfig/crio $(SYSCONFDIR)
	# install override file
	echo "$$CRIO_CONF_OVERRIDE" >$(DESTDIR)/etc/crio/crio.conf.d/01-crio-runc.conf
	# changes to unit and config files
	sed -i 's/sysconfig/default/g' $(SYSCONFDIR)/crio
	sed -i 's/sysconfig/default/g' $(UNITDIR)/crio.service
	sed -i 's/sysconfig/default/g' $(UNITDIR)/crio-wipe.service
	sed -i 's/\/usr\/local/\/usr/g' $(UNITDIR)/crio.service
	sed -i 's/\/usr\/local/\/usr/g' $(UNITDIR)/crio-wipe.service

override_dh_golang:

## cri-o 1.28.3~0

=== debian/changelog ===
cri-o (1.28.3~0) stable; urgency=medium

  * bump to v1.28.3

 -- Peter Hunt <haircommander@fedoraproject.org>  Wed, 10 Apr 2024 16:30:27 -0400

cri-o (1.28.2~0) stable; urgency=medium

  * bump to 1.28.2

 -- Peter Hunt <haircommander@fedoraproject.org>  Fri, 08 Dec 2023 12:14:13 -0500

=== debian/control ===
Source: cri-o
Section: devel
Priority: optional
Maintainer: Peter Hunt <haircommander@fedoraproject.org>
Build-Depends: debhelper (>=9),
    rsync,
    libgpgme11-dev,
    libseccomp-dev,
    golang-1.19 | golang-1.19-go,
    libglib2.0-dev,
    go-md2man,
    dh-golang,
    git
Standards-Version: 4.3.0
Homepage: https://github.com/cri-o/cri-o
Vcs-Git: https://gitlab.com/rhcontainerbot/cri-o
Vcs-Browser: https://gitlab.com/rhcontainerbot/cri-o

Package: cri-o
Architecture: any
Depends: ${misc:Depends},
    libgpgme11,
    libseccomp2,
    conmon,
    containers-common (>=0.1.27) | golang-github-containers-common,
    tzdata,
Suggests: cri-o-runc | runc (>=1.0.0),
    containernetworking-plugins,
Description: OCI-based implementation of Kubernetes Container Runtime Interface.
Replaces: cri-o-1.22,
   cri-o-1.23,
   cri-o-1.24,
   cri-o-1.26,
   cri-o-1.27

=== debian/rules ===
--- 
+++ 
@@ -26,7 +26,7 @@
 endif
 GO := GOPATH=$(BUILDDIR) GO111MODULE=off $(GO_BINARY)
 GO_BUILD := "$(GO) build"
-UPSTREAM_TAG=v1.28.1
+UPSTREAM_TAG=v1.28.3
 
 %:
 	dh_clean
